<?PHP

  $def_ldap_server = "localhost";
  $def_ldap_base   = "o=Brotherhood Of The Whitemice,c=US";

function ldap_get_uid_dn($uid, $ds) {
  $r=ldap_bind($ds);
  $sr=ldap_search($ds,$def_ldap_base, "(&(uid=$uid)(objectclass=posixaccount))");
  $info = ldap_get_entries($ds, $sr);
  if ($info["count"] > 0)
   {
    $user_dn = $info[0]["dn"];
   } else
      {
       $user_dn = "";
      }
  printf(" UID DN: $user_dn<BR>");
  return $user_dn;
 }

function ldap_oc_attr_list($oc, $ds) {
  $r=ldap_bind($ds);
  $sr=ldap_search($ds, $def_ldap_base, 
        "(&(cn=$oc)(objectclass=ldapconsoleobject))");
  $info = ldap_get_entries($ds, $sr);
  for ($i=0; $i < (count($info[0]["ldapconsoleattrib"])-1); $i++)
   {
    $data = split("\|", $info[0]["ldapconsoleattrib"][$i]);
    $attribute_data = split(",", $data[1]);
    for ($j=0; $j < count($attribute_data); $j++)
     {
      $value = split("=", $attribute_data[$j]);
      $attr_list[$data[0]][$value[0]] = $value[1];
     }
   }
  return $attr_list;
}

function ldap_array_from_attr($attr_list) {
  $attr_name  = "";
  $attr_count = 0;
  $data = split("\|", $attr_list); 
  for ($i=1; $i<count($data); $i++) 
   {
    $element = split(": ", $data[$i]);
    if ($attr_name == $element[0])
     { 
      $attr_count++;
     } else {
         $attr_name = $element[0];
         $attr_count = 0;
        };
    $attr_value = $element[1];
    $attr_array[$attr_name][$attr_count] = $attr_value;
   }
  return $attr_array;
}

function ldap_class_from_attr($attr_list) {
  $data = split("\|", $attr_list);
  return $data[0];
}

function ldap_process_changes($dn, $add_array, $change_array, $delete_array, $ds) {
  $notice_string = "";

  if (is_array($delete_array))
   {
    $notice_string = sprintf("%s Found %d entries to delete from object<br>",
                       $notice_string, count($delete_array));
    if (ldap_mod_del($ds, $dn, $delete_array))
     {
      $notice_string = sprintf("%s Delete successful.<br>", $notice_string);
     } else {
         $notice_string = sprintf("%s Delete failed.<br>", $notice_string);
        }
   }

  if (is_array($add_array)) 
   {
    $notice_string = sprintf("%s Found %d entries to add to object<br>",
                       $notice_string, count($add_array));
    if (ldap_mod_add($ds, $dn, $add_array))
     {
      $notice_string = sprintf("%s Add successful.<br>", $notice_string);
     } else {
         $notice_string = sprintf("%s Add failed.<br>", $notice_string);
        }
   }

  if (is_array($change_array)) 
   {
    $notice_string = sprintf("%s Found %d entries to change in object<br>",
                       $notice_string, count($change_array));
    if (ldap_mod_replace($ds, $dn, $change_array))
     {
      $notice_string = sprintf("%s Change successful.<br>", $notice_string);
     } else {
         $notice_string = sprintf("%s Change failed.<br>", $notice_string);
        }
   }

  return $notice_string;
}

?>
